/*---------------------------------------------------------------------------*\
  ==  == ====== ====   ====    |
                    \\     ||  | HZDR Multiphase Addon for OpenFOAM
  ======   //   ||  || ===//   | Website: https://doi.org/10.14278/rodare.767
  ||  ||  //    ||  // || \\   | Copyright (C) 2021 OpenFOAM Foundation
  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
-------------------------------------------------------------------------------
License
    This file is a derivative work of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "OFMemoryManagedField.H"

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::diameterModels::cudaUtilities::OFMemoryManagedField::
OFMemoryManagedField()
{
    this->resize(0);
}


Foam::diameterModels::cudaUtilities::OFMemoryManagedField::
OFMemoryManagedField(std::size_t size)
{
    this->resize(size);
}


Foam::diameterModels::cudaUtilities::OFMemoryManagedField::
OFMemoryManagedField(double* fieldPtr, std::size_t size)
:
    fieldPtr_(fieldPtr), size_(size)
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void  Foam::diameterModels::cudaUtilities::OFMemoryManagedField::
resize(std::size_t size)
{
    if(this->size_!=size)
    {
        cudaMallocManaged
        (
            &this->fieldPtr_, size*sizeof(double)
        );
        this->size_ = size;
    }
}


// ************************************************************************* //
