/*---------------------------------------------------------------------------*\
  ==  == ====== ====   ====    |
                    \\     ||  | HZDR Multiphase Addon for OpenFOAM
  ======   //   ||  || ===//   | Website: https://doi.org/10.14278/rodare.767
  ||  ||  //    ||  // || \\   | Copyright (C) 2021-2022 OpenFOAM Foundation
  ==  == ====== ====   ==  ==  | and Helmholtz-Zentrum Dresden-Rossendorf
-------------------------------------------------------------------------------
License
    This file is a derivative work of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "HZDRphaseCompressibleMomentumTransportModels.H"

// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

// -------------------------------------------------------------------------- //
// LES models
// -------------------------------------------------------------------------- //

#include "NicoudSigma.H"
makeLESModel(NicoudSigma);

#include "scaleSimilarity.H"
makePureStructuralLESModel(scaleSimilarity);

#include "Clark.H"
makePureStructuralLESModel(Clark);

#include "KetterlExtendedGradient.H"
makePureStructuralLESModel(KetterlExtendedGradient);

#include "Smagorinsky.H"
makeMixedStructuralLESModel(scaleSimilarity, Smagorinsky);
makeMixedStructuralLESModel(scaleSimilarity, NicoudSigma);
makeMixedStructuralLESModel(Clark, Smagorinsky);
makeMixedStructuralLESModel(Clark, NicoudSigma);
makeMixedStructuralLESModel(KetterlExtendedGradient, Smagorinsky);
makeMixedStructuralLESModel(KetterlExtendedGradient, NicoudSigma);

makeKobayashiStructuralLESModel(scaleSimilarity);
makeKobayashiStructuralLESModel(Clark);
makeKobayashiStructuralLESModel(KetterlExtendedGradient);

makeKleinStructuralLESModel(scaleSimilarity);
makeKleinStructuralLESModel(Clark);
makeKleinStructuralLESModel(KetterlExtendedGradient);


// ************************************************************************* //
